{% extends 'dashboard/dashboard_content.html' %}

{% block title %}
    CO Reports
{% endblock %}

{% block rightPane %}

    <div class="x_panel">
        <div class="x_title">
            <h2>
                <i class="fa fa-plus-circle"></i>
                CO Marks
            </h2>
            <div class="clearfix"></div>
        </div>

        <div class="x_content">
            <div class="row">
                <ul class="nav nav-tabs bar_tabs">
                    {% for department in departmentList %}
                        {% if department.pk == departmentInstance.pk %}
                            <li class="active" onmouseover="$(this).css('cursor','pointer');">
                                <a aria-expanded="true"
                                   id={{ department.pk }}
                                           data-toggle="tab" name="departmentTab">
                                    {{ department.acronym }}
                                </a>
                            </li>
                        {% else %}
                            <li class="" onmouseover="$(this).css('cursor','pointer');">
                                <a aria-expanded="false"
                                   id={{ department.pk }}
                                           data-toggle="tab" name="departmentTab">
                                    {{ department.acronym }}
                                </a>
                            </li>
                        {% endif %}
                    {% endfor %}
                </ul>
                <ul class="nav nav-tabs bar_tabs">
                    {% for semester in semesterList %}
                        {% if semester.semesterInstance.pk == semesterInstance.pk %}
                            <li class="active" onmouseover="$(this).css('cursor','pointer');">
                                <a aria-expanded="true"
                                   id={{ semester.semesterInstance.pk }}
                                           data-toggle="tab" name="semesterTab">
                                    {{ semester.displayText }}
                                </a>
                            </li>
                        {% else %}
                            <li class="" onmouseover="$(this).css('cursor','pointer');">
                                <a aria-expanded="false"
                                   id={{ semester.semesterInstance.pk }}
                                           data-toggle="tab" name="semesterTab">
                                    {{ semester.displayText }}
                                </a>
                            </li>
                        {% endif %}
                    {% endfor %}
                </ul>
                <ul class="nav nav-tabs bar_tabs">
                    {% for course in courseList %}
                        {% if forloop.counter == 1 %}
                            <li {% if staffCourseInstance.pk == course.staffCourseInstance.pk %}class="active" {% else %}
                                class="" {% endif %} onmouseover="$(this).css('cursor','pointer');">
                                <a aria-expanded="true"
                                   id={{ course.staffCourseInstance.pk }}
                                           data-toggle="tab" name="courseTab">
                                    {{ course.displayText }}
                                </a>
                            </li>
                        {% else %}
                            <li {% if staffCourseInstance.pk == course.staffCourseInstance.pk %}class="active" {% else %}
                                class="" {% endif %} onmouseover="$(this).css('cursor','pointer');">
                                <a aria-expanded="false"
                                   id={{ course.staffCourseInstance.pk }}
                                           data-toggle="tab" name="courseTab">
                                    {{ course.displayText }}
                                </a>
                            </li>
                        {% endif %}
                    {% endfor %}
                </ul>

                {% if noSemester %}
                    <div class="x_content">
                        <div class="alert alert-danger" role="alert" align="center">
                            <h4 style="font-size: 18px"> No Semester Plan has Created </h4>
                        </div>
                    </div>
                {% elif noCourses %}
                    <div class="x_content">
                        <div class="alert alert-danger" role="alert" align="center">
                            <h4 style="font-size: 18px"> No Courses are available </h4>
                        </div>
                    </div>
                {% else %}
                    <div class="alert alert-success" role="alert" align="center">
                        <div><h4><strong>{{ staffCourseInstance.course }}</strong>&nbsp;&nbsp;handled
                            by&nbsp;&nbsp;<strong>
                                {% for staff in staffCourseInstance.staffs.all %}
                                    {{ staff }}&nbsp;
                                {% endfor %}
                            </strong></h4>
                        </div>
                    </div>

                    <div class="form-group">
                        <div class="col-md-4 col-sm-4 col-xs-12">
                            <select class="form-control" id="unitTestSelection"
                                    required>
                                <option value="" disabled selected>Choose Unit Test</option>
                                <option value="1">UNIT TEST I</option>
                                <option value="2">UNIT TEST II</option>
                                <option value="3">UNIT TEST III</option>
                            </select>
                        </div>
                    </div>
                {% endif %}

                <div id="alertFieldNoPattern" class="x_content" style="display: none">
                    <div class="alert alert-warning" role="alert" align="center">
                        <h4 style="font-size: 18px"> Question Paper pattern for CO is not set </h4>
                    </div>
                </div>

                <div id="infoFieldNoStudent" class="x_content" style="display: none">
                    <div class="alert alert-info" role="alert" align="center">
                        <h4 style="font-size: 18px"> No Students are enrolled for the respective course </h4>
                    </div>
                </div>

                <div id="displayContents" style="display: none">
                    <div class="col-md-offset-8">
                        <button type="button" class="btn btn-primary" id='getGraph'>
                            View Graph
                        </button>
                        <button type="button" class="btn btn-primary" id='getPdf'>
                            Generate PDF
                        </button>
                    </div>
                    <div class="x_content">
                        <form method="POST">{% csrf_token %}
                            <div id="hiddenUnitTestNumber" style="display: none"></div>
                            <input type="hidden" name="hiddenStaffCoursePk" value="{{ staffCourseInstance.pk }}">
                            <div class="table-responsive">
                                <table id="table" class="table table-striped table-condensed table-hover">
                                    <thead>
                                    <tr id="headSection">
                                    </tr>
                                    <tr id="coSection"></tr>
                                    <tr id="markSection"></tr>
                                    </thead>
                                    <tbody id="bodySection">
                                    </tbody>
                                </table>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>


    <form id="dummyForm" method="POST">
        {% csrf_token %}
    </form>


    <script type="text/javascript">

        function getCookie(name) {
            var cookieValue = null;
            if (document.cookie && document.cookie != '') {
                var cookies = document.cookie.split(';');
                for (var i = 0; i < cookies.length; i++) {
                    var cookie = jQuery.trim(cookies[i]);
                    // Does this cookie string begin with the name we want?
                    if (cookie.substring(0, name.length + 1) == (name + '=')) {
                        cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                        break;
                    }
                }
            }
            return cookieValue;
        }

        $('document').ready(function () {
            $('[name="departmentTab"]').click(function () {

                var $hiddenInput = $('<input/>', {
                    type: 'hidden',
                    value: getCookie('csrftoken'),
                    name: 'csrfmiddlewaretoken'
                });
                $hiddenInput.appendTo('#dummyForm');

                var $hiddenInput = $('<input/>', {type: 'hidden', value: this.id, name: 'departmentPk'});
                $hiddenInput.appendTo('#dummyForm');

                $('#dummyForm').submit();

            });
        });

        $('document').ready(function () {
            $('[name="semesterTab"]').click(function () {

                var $hiddenInput = $('<input/>', {
                    type: 'hidden',
                    value: getCookie('csrftoken'),
                    name: 'csrfmiddlewaretoken'
                });
                $hiddenInput.appendTo('#dummyForm');

                var $hiddenInput = $('<input/>', {type: 'hidden', value: this.id, name: 'semesterPk'});
                $hiddenInput.appendTo('#dummyForm');

                $('#dummyForm').submit();

            });
        });

        $('document').ready(function () {
            $('[name="courseTab"]').click(function () {

                var $hiddenInput = $('<input/>', {
                    type: 'hidden',
                    value: getCookie('csrftoken'),
                    name: 'csrfmiddlewaretoken'
                });
                $hiddenInput.appendTo('#dummyForm');

                var $hiddenInput = $('<input/>', {type: 'hidden', value: this.id, name: 'staffCoursePk'});
                $hiddenInput.appendTo('#dummyForm');


                $('#dummyForm').submit();

            });
        });

    </script>
    <script type="text/javascript">

        $("document").ready(function () {
            var unitTestNumber = '{{ unitTestNumber }}';
            $('#unitTestSelection').val(unitTestNumber);
            if (unitTestNumber != '') {
                if (unitTestNumber == undefined) {

                }
                else {
                    myfunction();
                }
            }
        });

        function myfunction() {
            var unitTestNumber = $('#unitTestSelection').val();
            var staffCoursePk = '{{ staffCourseInstance.pk }}';

            $.ajax({
                type: "POST",
                data: {
                    unitTestNumberAjax: unitTestNumber,
                    staffCoursePkAjax: staffCoursePk,
                    csrfmiddlewaretoken: getCookie('csrftoken'),
                },
                url: '{% url 'coReports' %}',

                success: function (data) {
                    if (data.avail == 'true') {
                        if (data.studentAvail == 'true') {
                            $('#displayContents').show();
                            $('#infoField').show();
                            $('#alertFieldNoPattern').hide();
                            $('#infoFieldNoStudent').hide();
                            document.getElementById('hiddenUnitTestNumber').innerHTML = '<input type="hidden" name="editUnitTestNumber" value="' + unitTestNumber + '">';

                            document.getElementById('coSection').innerHTML = '';
                            document.getElementById('markSection').innerHTML = '';
                            document.getElementById('headSection').innerHTML = '' +
                                '<th rowspan="3">S.No.</th>' +
                                '<th rowspan="3">Register Number</th>' +
                                '<th rowspan="3">Student Name</th>';

                            $.each(data.coPatternList, function (key, val) {
                                document.getElementById('headSection').innerHTML += '<th>Q.' + val.userPrespectiveQuestionNumber + '</th>';
                                document.getElementById('coSection').innerHTML += '<th>CO' + val.coMapped + '</th>';
                                document.getElementById('markSection').innerHTML += '<th>' + val.maximumMark + 'M</th>';
                            });
                            document.getElementById('coSection').innerHTML += '<th>Total</th>';
                            document.getElementById('markSection').innerHTML += '<th>Marks</th>';

                            document.getElementById('bodySection').innerHTML = '';

                            counter = 1;
                            $.each(data.coMarkList, function (key, val) {
                                document.getElementById('bodySection').innerHTML += '<tr id="body' + key + '"></tr>';
                                if (val.totalMarks == 'AB' || val.totalMarks == 'Not entered') {
                                    document.getElementById('body' + key).innerHTML +=
                                        '<td>' + counter++ + '</td>' +
                                        '<td>' + val.registerNumber + '</td>' +
                                        '<td>' + val.studentName + '</td>';
                                }
                                else {
                                    document.getElementById('body' + key).innerHTML +=
                                        '<td>' + counter++ + '</td>' +
                                        '<td>' + val.registerNumber + '</td>' +
                                        '<td>' + val.studentName + '</td>';
                                }

                                is_avail = false;
                                $.each(val.coList, function (hai, item) {
                                    is_avail = true;
                                    if (val.markEqualsCo == 'true') {
                                        document.getElementById('body' + key).innerHTML += '<td>' + item + '</td>';
                                    }
                                    else {
                                        document.getElementById('body' + key).innerHTML += '<td bgcolor="#ff3200">' + item + '</td>';
                                    }
                                });
                                if (is_avail == false) {
                                    document.getElementById('body' + key).innerHTML += '<td align="center" colspan="' + parseInt(data.totalQuestions) + '"></td>';
                                    document.getElementById('body' + key).innerHTML += '<td>' + val.totalMarks + '</td>';
                                }
                                else {
                                    document.getElementById('body' + key).innerHTML += '<td>' + val.totalMarks + '</td>';
                                }
                            });
                        }
                        else {
                            $('#displayContents').hide();
                            $('#infoField').hide();
                            $('#alertFieldNoPattern').hide();
                            $('#infoFieldNoStudent').show();
                        }
                    }
                    else {
                        $('#displayContents').hide();
                        $('#infoField').hide();
                        $('#alertFieldNoPattern').show();
                        $('#infoFieldNoStudent').hide();
                    }
                }
            });
        }

        $(document).on("change", '#unitTestSelection', function (e) {
            myfunction();
        });

        {% if not noSemester and not noCourses %}
            $('document').ready(function () {
                $('#getPdf').click(function () {
                    var unitTestNumber = $('#unitTestSelection').val();
                    if (unitTestNumber == '1') {
                        window.open('{% url 'pdfCoMarks' staffCoursePk=staffCourseInstance.pk unitTestNumber=1 %}', '_self');
                    }
                    else if (unitTestNumber == '2') {
                        window.open('{% url 'pdfCoMarks' staffCoursePk=staffCourseInstance.pk unitTestNumber=2 %}', '_self');
                    }
                    else if (unitTestNumber == '3') {
                        window.open('{% url 'pdfCoMarks' staffCoursePk=staffCourseInstance.pk unitTestNumber=3 %}', '_self');
                    }
                });

                $('#getGraph').click(function () {
                    var unitTestNumber = $('#unitTestSelection').val();
                    if (unitTestNumber == '1') {
                        window.open('{% url 'viewGraph' staffCoursePk=staffCourseInstance.pk unitTestNumber=1 %}', '_self');
                    }
                    else if (unitTestNumber == '2') {
                        window.open('{% url 'viewGraph' staffCoursePk=staffCourseInstance.pk unitTestNumber=2 %}', '_self');
                    }
                    else if (unitTestNumber == '3') {
                        window.open('{% url 'viewGraph' staffCoursePk=staffCourseInstance.pk unitTestNumber=3 %}', '_self');
                    }
                });
            });
        {% endif %}

    </script>
{% endblock %}